/**
 * VCOM cubesat control terminal
 *
 * Created at VZLU for VZLUSAT 2
 * March 2020
 */

#define _GNU_SOURCE // needed for asprintf

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>
#include <assert.h>
#include <libgen.h>

#include "tcpp/tcpp.h"

/* this file is generated by CMake using compile-time options */
#include "conf_vcom.h"

#include "vcom_config.h"

/* CSP */
#include "csp/csp.h"
#include "csp/drivers/usart.h"
#include "csp/csp_debug.h"
#include "csp/crypto/csp_hmac.h"
#if VCOM_ENABLE_CAN
#include "csp/drivers/can_socketcan.h"
#endif

/* Console */
#include "console/console.h"

/* Drivers / Util */

#include "argtable3.h"
#include "nii.h"
#include "csp_server.h"
#include "posix/tcpbridge.h"
#include "posix/tcpcli.h"

#include "commands/register_cmds.h"

#include "console/prefix_match.h"
#include "commands/lp_txn_conf.h"
#include "batch_run.h"
#include "i2cif.h"
#include "kiss_net.h"
#include "vcom_debug.h"
#include "plugins.h"
#include "utils/hex.h"

static void sighandler(int signal)
{
    (void)signal;
    exit(EXIT_SUCCESS);
}

static void exithandler(void)
{
    #if defined(VCOM_STATIC_CMDS)
    client_cmds_exit();
    #endif

    // Shutdown threads
    if (vcom_config.use_tcp_cli) {
        tcpcli_done();
    }
    if (vcom_config.use_tcp_srv) {
        if (vcom_config.tcp_srv_legacy) {
            tcpbridge_done();
        } else {
            tcpp_shutdown();
        }
    }

    if (vcom_config.use_kiss_net) {
        int ret = kiss_net_done();
        if (ret != CSP_ERR_NONE)
            vd_warn("KISS_NET closing returned error code %d", ret);
    }

    if(vcom_config.logopt.enable && vcom_config.logopt.fp) {
        fflush(vcom_config.logopt.fp);
        fclose(vcom_config.logopt.fp);
    }
}

/**
 * Impl for a weak stub in libcsp
 */
void csp_assert_fail_action(const char *assertion, const char *file, int line)
{
    vd_error("libcsp assertion failed in %s:%d: %s", file, line, assertion);
    exit(EXIT_FAILURE);
}

static csp_iface_t *csp_if_kiss;
#if VCOM_ENABLE_CAN
static csp_iface_t *csp_if_can[VCOM_MAX_NUM_SAME_IFC];
#endif

/* CLI arguments */
struct cli_args {
    struct arg_lit *help;
    struct arg_lit *version;
    struct arg_lit *dump_config;

    struct arg_str *configfile;
    struct arg_str *colors;
    struct arg_str *textlog;
    struct arg_lit *paranoid;

    struct arg_int *address;

    struct arg_lit *use_nii;
    struct arg_int *nii_port;

    struct arg_str *batch_file;
    struct arg_lit *batch_fexit;
    struct arg_lit *batch_startup;

    struct arg_str *cli_adr_port;
    struct arg_str *cli_pw;
    struct arg_lit *cli_legacy_tcp;

    struct arg_end *end;
};

int console_write_ctx(console_ctx_t *ctx, const char *text, size_t len) {
    if (!ctx || !ctx->out) {
        return -1;
    }

    size_t written = fwrite(text, 1, len, ctx->out);

    if(vcom_config.logopt.enable && vcom_config.logopt.fp) {
        vd_log_to_file(text, len);
    }

    if (written != len) {
        return -1;
    }

    return (int) written;
}

int main(int argc, char *argv[])
{
    struct cli_args args = {
            // Info options
            .help         = arg_lit0("h", "help", "Print help and exit"),
            .version      = arg_lit0("V", "version", "Print version and exit"),
            .dump_config  = arg_lit0(NULL, "show-config", "Print all used config before starting"),

            // Settings
            .configfile   = arg_str0("c", "config", "FILE", "Config file to use (JSON, default vcom.json if found)"),
            .colors       = arg_str0(NULL, "color", "{always|never|auto}", "Enable/disable terminal colors"),
            .textlog      = arg_str0("t", "logs", "DIR", "Directory to store TXT logs (default ./logs)."),
            .paranoid     = arg_lit0("P", "paranoid", "Do not allow loading plugins with unknown/invalid revision."),

            // CSP settings
            .address      = arg_int0("a", "addr", "ADDRESS", "Set CSP address (default: 8)"),

            // Run modes
            .use_nii    = arg_lit0("n", "nii", "Remote non-interactive mode: operate over TCP"),
            .nii_port = arg_int0("N", "nii-port", "PORT", "NII mode custom port (default 9500)"),

            .batch_file   = arg_str0("i", "input", "<file>", "Batch non-interactive mode, run commands from a file. Pass \"--\" for stdin (default)"),
            .batch_fexit  = arg_lit0("e", "fexit", "Stop execution of batch, when any command fails"),
            .batch_startup = arg_lit0("S", "batch-startup", "Drop to console or NII when batch is done"),

            // Interfaces

            // peer interface is optional and usually specified at call time, so it's kept as a flag,
            // other interfaces must be set up through the config file
            .cli_adr_port = arg_str0("p", "peer", "ADDRESS[:PORT]", "Connect to another VCOM instance or CSP emulator"),
            .cli_pw       = arg_str0("w", "pw", "<pw>", "Set TCP client password, 8 chars, defaults to none (8 null bytes)"),
            .cli_legacy_tcp   = arg_lit0(NULL, "peer-legacy", "Use the old \"TCP bridge\" connection method for TCP client (with port 9209)"),

            .end          = arg_end(20),
    };

    /* Find the program's name (no path) */
    const char *cmdname = basename(argv[0]);

    int nerr = arg_parse(argc, argv, (void **) &args);
    if (nerr > 0) {
        arg_print_errors(stderr, args.end, cmdname);
        exit(EXIT_FAILURE);
    }

    /* txn defaults, will be overwritten by config if a file is loaded */
    cmd_lp_txn_conf.txn_verbose = true;
    cmd_lp_txn_conf.txn_show_pretty = true;
    cmd_lp_txn_conf.txn_annotated = true;
    cmd_lp_txn_conf.txn_show_hex = false;
    cmd_lp_txn_conf.txn_show_requests = true;
    cmd_lp_txn_conf.txn_show_json = false;

    if (args.configfile->count) {
        if (access(args.configfile->sval[0], R_OK) == 0) {
            vcom_load_config_from_file(args.configfile->sval[0]);
        } else {
            vd_error("Config file %s does not exist or is not readable!", args.configfile->sval[0]);
            exit(EXIT_FAILURE);
        }
    } else {
        if (access("vcom.json", R_OK) == 0) {
            vcom_load_config_from_file("vcom.json");
        } else {
            vd_warn("Default config file vcom.json not found!");

            // this is not great, at least try to start logging
            vcom_start_log();
        }
    }

    /* help arg */
    if (args.help->count) {
        FILE *f = stdout;
        fprintf(f, "Cubesat control terminal v%s\r\n\r\nUsage: ", VCOM_VERSION);
        fputs("\x1b[36m", f);
        fputs(cmdname, f);
        arg_print_syntax(f, (void **) &args, NULL);
        fputs("\x1b[m\r\n\r\n", f);
        arg_print_glossary(f, (void **) &args, "  \x1b[32m%-20s\x1b[m %s\r\n");
        fputs("\r\n", f);
        exit(EXIT_SUCCESS);
    }

    /* version arg */
    if (args.version->count) {
        fprintf(stdout, "Cubesat control terminal v%s\r\n", VCOM_VERSION);
        exit(EXIT_SUCCESS);
    }

    if (args.colors->count) {
        const char *clr = args.colors->sval[0];
        if (0 == strcasecmp(clr, "auto")) {
            vcom_config.colors = VCOM_COLORS_AUTO;
        } else if (0 == strcasecmp(clr, "always") || 0 == strcasecmp(clr, "on") || 0 == strcmp(clr, "1")) {
            vcom_config.colors = 1;
        } else {
            vcom_config.colors = 0;
        }
    }

    /* Copy/move parsed args to config */

    /* Own address */
    if (args.address->count) {
        int val = args.address->ival[0];
        if ((val < 0) || (val > CSP_ID_HOST_MAX)) {
            vd_error("CSP address %d out of range.", val);
            exit(EXIT_FAILURE);
        }
        vcom_config.cspopt.address = (uint8_t) val;
    }

    /* Text log directory */
    if (args.textlog->count) {
        vcom_config.logopt.enable = true;
        vcom_config.logopt.dir = strdup(args.textlog->sval[0]);
    }

    /* Paranoid mode */
    if(args.paranoid->count) {
        vcom_config.paranoid = true;
    }

    /* NII */
    if (args.use_nii->count) {
        vcom_config.use_nii = true;

        // unless txn config was explicitly changed, go to NII defaults
        if (!vcom_config.txn_config_changed) {
            cmd_lp_txn_conf.txn_verbose = false;
            cmd_lp_txn_conf.txn_show_pretty = false;
            cmd_lp_txn_conf.txn_annotated = false;
            cmd_lp_txn_conf.txn_show_hex = false;
            cmd_lp_txn_conf.txn_show_requests = false;

            // we want only response JSONs
            cmd_lp_txn_conf.txn_show_json = true;
        }

        /* NII with custom port */
        if (args.nii_port->count) {
            int val = args.nii_port->ival[0];
            if ((val < 1000) || (val > 32767)) {
                vd_error("NII port %d out of range.", val);
                exit(EXIT_FAILURE);
            }
            vcom_config.nii_port = val;
            vcom_config.use_nii = true;
        }
    }

    if (args.batch_file->count) {
        vcom_config.batch_file_name = strdup(args.batch_file->sval[0]);
        vcom_config.use_batch_input = true;
        vcom_config.batch_fail_exit = args.batch_fexit->count > 0;
        vcom_config.batch_startup = args.batch_startup->count > 0;
    }

    /* Peer address */
    if (args.cli_adr_port->count) {
        vcom_config.use_tcp_cli = true;
        vcom_config.tcp_cli_adr_port = strdup(args.cli_adr_port->sval[0]);

        if (args.cli_pw->count) {
            vcom_config.tcp_cli_pw = strdup(args.cli_pw->sval[0]);
        }
    }

    /* ------------ Show active configuration for verification -------------- */
    if (args.dump_config->count) {
        vd_debug("\n--- VCOM options used ---\n");

        vd_debug("Plug-in paths:");
        
        char** path = vcom_config.plugin_libs;
        if (path) {
            while (*path) {
                vd_debug("    \"%s\"", *path);
                path++;
            }
        }
        else {
            vd_error("Config not found!");
        }

        if (vcom_config.paranoid) {
            vd_debug("Paranoid mode enabled");
        } else {
            vd_debug("Paranoid mode disabled");
        }

        if(vcom_config.logopt.enable) {
            vd_debug("Log enabled, dir: \"%s\"", vcom_config.logopt.dir);
        } else {
            vd_debug("Logging disabled!");
        }
        vd_debug("Initial routes: \"%s\"", vcom_config.initial_routes_file);
        vd_debug("Colors: %d", vcom_config.colors);

        vd_debug("CSP debug: ERROR=%d, WARN=%d, INFO=%d, BUFFER=%d, PACKET=%d, PROTOCOL=%d, LOCK=%d, HEXDUMP=%d,",
                 vcom_config.csp_debug_level[0],
                 vcom_config.csp_debug_level[1],
                 vcom_config.csp_debug_level[2],
                 vcom_config.csp_debug_level[3],
                 vcom_config.csp_debug_level[4],
                 vcom_config.csp_debug_level[5],
                 vcom_config.csp_debug_level[6],
                 vcom_config.csp_debug_level[7]
        );

        vd_debug("CSP hostname: \"%s\"", vcom_config.cspopt.hostname);
        vd_debug("    address: %d", (int) vcom_config.cspopt.address);
        vd_debug("    conn_max: %d", (int) vcom_config.cspopt.conn_max);
        vd_debug("    conn_queue_length: %d", (int) vcom_config.cspopt.conn_queue_length);
        vd_debug("    fifo_length: %d", (int) vcom_config.cspopt.fifo_length);
        vd_debug("    port_max_bind: %d", (int) vcom_config.cspopt.port_max_bind);
        vd_debug("    rdp_max_window: %d", (int) vcom_config.cspopt.rdp_max_window);
        vd_debug("    buffers: %d", (int) vcom_config.cspopt.buffers);
        vd_debug("    buffer_data_size: %d", (int) vcom_config.cspopt.buffer_data_size);
        vd_debug("    conn_dfl_so: 0x%08"PRIu32, vcom_config.cspopt.conn_dfl_so);

        vd_debug("RDP window_size: %d", vcom_config.rdpopt.window_size);
        vd_debug("    conn_timeout_ms: %d", vcom_config.rdpopt.conn_timeout_ms);
        vd_debug("    packet_timeout_ms: %d", vcom_config.rdpopt.packet_timeout_ms);
        vd_debug("    delayed_acks: %d", vcom_config.rdpopt.delayed_acks);
        vd_debug("    ack_timeout_ms: %d", vcom_config.rdpopt.ack_timeout_ms);
        vd_debug("    ack_delay_count: %d", vcom_config.rdpopt.ack_delay_count);

        if (vcom_config.use_batch_input) {
            vd_debug("Batch mode enabled, infile=\"%s\", fail_exit=%d", vcom_config.batch_file_name, vcom_config.batch_fail_exit);
        } else {
            vd_debug("Batch mode disabled");
        }

        if (vcom_config.use_nii) {
            vd_debug("NII enabled, port=%d", vcom_config.nii_port);
        } else {
            vd_debug("NII disabled");
        }

        if (vcom_config.use_tcp_cli) {
            vd_debug("TCPCL enabled, addr_port=\"%s\", pw=\"%s\", legacy=%d", vcom_config.tcp_cli_adr_port, vcom_config.tcp_cli_pw, vcom_config.tcp_cli_legacy);
        } else {
            vd_debug("TCPCL disabled");
        }

        if (vcom_config.use_tcp_srv) {
            vd_debug("TCPD enabled, port=%d, pw=\"%s\", legacy=%d", vcom_config.tcp_srv_port, vcom_config.tcp_srv_pw, vcom_config.tcp_srv_legacy);
        } else {
            vd_debug("TCPD disabled");
        }

        if (vcom_config.use_i2c) {
            vd_debug("I2C enabled, dev=\"%s\", sa=\"%s\", sd=\"%s\"", vcom_config.i2c_devfile, vcom_config.i2c_safile, vcom_config.i2c_sdfile);
        } else {
            vd_debug("I2C disabled");
        }

        if (vcom_config.use_uart) {
            vd_debug("UART enabled, dev=\"%s\", baud=%d", vcom_config.uart_device, vcom_config.uart_baud);
        } else {
            vd_debug("UART disabled");
        }

#if VCOM_ENABLE_CAN
        for(size_t i = 0; i < vcom_config.num_cans; i++) {
            if(vcom_config.use_cans[i]) {
                vd_debug("CAN #%d enabled, dev=\"%s\", baud=%d", (int)i, vcom_config.can_devices[i], vcom_config.can_bauds[i]);
            }
        }
        if(!vcom_config.num_cans) {
            vd_debug("CAN disabled");
        }
#else
        vd_debug("CAN disabled by compile options");
#endif

        if (vcom_config.use_kiss_net) {
            vd_debug("KISS over network enabled, host ip=\"%s\", host port=%d",
                     vcom_config.kiss_net_host_ip, vcom_config.kiss_net_host_port);
        } else {
            vd_debug("KISS over network disabled");
        }

        vd_debug("HMAC key: \"%s\"", vcom_config.hmac_key);
    }

    vd_info("\nStarting\n");

    /* ------------ CONFIG LOADED - START VCOM ----------------*/

    atexit(exithandler);
    signal(SIGINT, sighandler);

    // debug hook can be set before CSP init, and should, because init can log errors.
    csp_debug_hook_set(vcom_csp_debug_hook);

    // set initial CSP debug levels
    for (int i = 0; i < 8; i++) {
        csp_debug_level_enabled[i] = vcom_config.csp_debug_level[i];
    }

    /* CSP init */
    csp_conf_t conf;
    csp_conf_get_defaults(&conf);
    conf.hostname = vcom_config.cspopt.hostname;
    conf.model = "vcom";
    char rev[64];
    sprintf(rev, "%s " VCOM_GITREV, VCOM_VERSION);
    conf.revision = rev;
    conf.conn_max = vcom_config.cspopt.conn_max;
    conf.conn_queue_length = vcom_config.cspopt.conn_queue_length;
    conf.fifo_length = vcom_config.cspopt.fifo_length;
    conf.port_max_bind = vcom_config.cspopt.port_max_bind;
    conf.buffers = vcom_config.cspopt.buffers;
    conf.buffer_data_size = vcom_config.cspopt.buffer_data_size;
    conf.address = vcom_config.cspopt.address;
    conf.conn_dfl_so = vcom_config.cspopt.conn_dfl_so;

    // HMAC required, hence set HMAC key
    if (conf.conn_dfl_so & CSP_O_HMAC)
    {
        uint8_t hmac_key[16];
        (void) hex2bin(vcom_config.hmac_key, strlen(vcom_config.hmac_key), hmac_key, sizeof(hmac_key));
        (void) csp_hmac_set_key(hmac_key, sizeof(hmac_key));
    }

    int rv = csp_init(&conf);
    if (CSP_ERR_NONE != rv) {
        vd_error("CSP init error %d", rv);
        exit(EXIT_FAILURE);
    }

    // Configure RDP
    csp_rdp_set_opt(
        vcom_config.rdpopt.window_size,
        vcom_config.rdpopt.conn_timeout_ms,
        vcom_config.rdpopt.packet_timeout_ms,
        vcom_config.rdpopt.delayed_acks,
        vcom_config.rdpopt.ack_timeout_ms,
        vcom_config.rdpopt.ack_delay_count);

    /* Add interfaces */

    if (vcom_config.use_tcp_cli && vcom_config.tcp_cli_adr_port) {
        /* Configure TCP client and set it as the default interface */
        tcpcli_init();

        struct tcpcli_config cliconf = {
                .address_port = vcom_config.tcp_cli_adr_port,
                .def_port = vcom_config.tcp_cli_legacy ? CSP_TCP_CLI_PORT : TCPP_PORT,
                .pp_hello = !vcom_config.tcp_cli_legacy,
        };

        if (vcom_config.tcp_cli_pw) {
            strncpy((char *) cliconf.pp_password, vcom_config.tcp_cli_pw, TCPP_PASSWORD_LEN);
        }

        rv = tcpcli_start(&cliconf);
        if (rv != 0) {
            vd_error("TCP client start error: %d", rv);
            exit(EXIT_FAILURE);
        }
    }

#if VCOM_ENABLE_CAN
    for(size_t i = 0; i < vcom_config.num_cans; i++) {
        if (vcom_config.use_cans[i]) {
            csp_iface_t * iface = NULL;
            char iface_name[16];
            snprintf(iface_name, 16, CSP_IF_CAN_DEFAULT_NAME "%d", (int)i);
	        int res = csp_can_socketcan_open_and_add_interface(vcom_config.can_devices[i], iface_name, vcom_config.can_bauds[i], false, &iface);
            if(res != CSP_ERR_NONE) {
                vd_error("failed to add CAN interface [%s]", vcom_config.can_devices[i]);
                exit(EXIT_FAILURE);
            }
            csp_if_can[i] = iface;
        }
    }
    
#endif

    if (vcom_config.use_uart) {
        /* Configure UART and set it as the default CSP interface */
        static struct csp_usart_conf csp_kiss_driver;
        csp_kiss_driver.device = vcom_config.uart_device;
        csp_kiss_driver.baudrate = vcom_config.uart_baud;

        csp_usart_open_and_add_kiss_interface(&csp_kiss_driver, "KISS", &csp_if_kiss);
    }

    if (vcom_config.use_tcp_srv) {
        if (vcom_config.tcp_srv_legacy) {
            /**
             * TCP Bridge interface
             */
            tcpbridge_init(vcom_config.tcp_srv_port);
            tcpbridge_start();
        } else {
            /* TCP P2P */
            struct tcpp_config tcpp_config = {
                    .password = { /* no pw */ },
                    .allowed_addr_range_start = 0,
                    .allowed_addr_range_end = CSP_ID_HOST_MAX - 1,
            };

            strncpy((char*) tcpp_config.password, vcom_config.tcp_srv_pw, TCPP_PASSWORD_LEN);
            tcpp_start(&tcpp_config);
        }
    }

    // If routes were not loaded from a file and only 1 interface is enabled,
    // add it as the default route.
    if (NULL == vcom_config.initial_routes_file) {
        int num_ifaces = (int) vcom_config.use_uart +
                         (int) vcom_config.use_i2c +
                         (int) vcom_config.use_tcp_cli +
                         (int) vcom_config.use_kiss_net +
                         (int) (vcom_config.use_tcp_srv && vcom_config.tcp_srv_legacy);
#if VCOM_ENABLE_CAN
        for(size_t i = 0; i < vcom_config.num_cans; i++) {
            if(vcom_config.use_cans[i]) {
                num_ifaces++;
            }
        }
#endif
        csp_iface_t *def_ifc = NULL;

        if (0 == num_ifaces) {
            vd_debug("No interfaces enabled, adding default route via LOOP");
            vd_debug("[tip] Use the config file to define interfaces.");

            def_ifc = csp_iflist_get_by_name("LOOP");
            assert(def_ifc);
            csp_route_set(CSP_DEFAULT_ROUTE, def_ifc, CSP_NODE_MAC);
        } else if (1 == num_ifaces) {
            if (vcom_config.use_uart) {
                def_ifc = csp_if_kiss;
            } else if (vcom_config.use_i2c) {
                def_ifc = &csp_if_i2c;
            } else if (vcom_config.use_tcp_cli) {
                def_ifc = &csp_if_tcpcli;
            } else if (vcom_config.use_kiss_net) {
                def_ifc = &csp_if_kiss_net;
            } else if (vcom_config.use_tcp_srv && vcom_config.tcp_srv_legacy) {
                def_ifc = &csp_if_tcpbridge;
            }
#if VCOM_ENABLE_CAN
            else if (vcom_config.num_cans) {
                for(size_t i = 0; i < vcom_config.num_cans; i++) {
                    if(vcom_config.use_cans[i]) {
                        def_ifc = csp_if_can[i];
                    }
                }
            }
#endif

            if (def_ifc) {
                vd_info("Adding default route via %s", def_ifc->name);
                csp_route_set(CSP_DEFAULT_ROUTE, def_ifc, CSP_NODE_MAC);
            }
        } else {
            vd_debug("More than 1 interface enabled, not setting default route!");
        }
    }

    /**
     * Tasks
     */

    /* Router */
    vd_info("Start CSP router");
    csp_route_start_task(8192*16, 0);

    /* Server */
    vd_info("Start CSP server");
    static pthread_t hCspServer;
    pthread_create(&hCspServer, NULL, csp_server, NULL);

    // Wait for CSP to init it's buffers etc
    usleep(100000);

    if (vcom_config.use_i2c
        && vcom_config.i2c_devfile
        && vcom_config.i2c_safile
        && vcom_config.i2c_sdfile
    ) {
        vd_debug("Start I2C rx helper");
        struct i2cif_config iic = {
            .bus_device = vcom_config.i2c_devfile,
            .slave_addr_file = vcom_config.i2c_safile,
            .slave_data_file = vcom_config.i2c_sdfile,
        };
        i2cif_start(&iic);
    }

    if (vcom_config.use_kiss_net) {
        vd_debug("Start and enable KISS over network");

        kiss_net_config_t kiss_net_config = {
            .host_ip = vcom_config.kiss_net_host_ip,
            .host_port = vcom_config.kiss_net_host_port,
        };

        kiss_net_start(&kiss_net_config);
    }


    /* initial route load */
    extern char x_rtable_buffer[CSP_RTABLE_LOAD_MAX_STRLEN];
    extern console_err_t cmd_csp_route_load_hook(char *buffer, size_t capacity, const char *fname);
    if (vcom_config.initial_routes_file) {
        if (access(vcom_config.initial_routes_file, R_OK) == 0) {
            vd_debug("Loading initial routes from %s", vcom_config.initial_routes_file);
            if (CONSOLE_OK == (rv = cmd_csp_route_load_hook(x_rtable_buffer, CSP_RTABLE_LOAD_MAX_STRLEN, vcom_config.initial_routes_file))) {
                x_rtable_buffer[CSP_RTABLE_LOAD_MAX_STRLEN - 1] = 0;
                vd_debug("Routes to load: %s", x_rtable_buffer);
                csp_rtable_load(x_rtable_buffer);
            } else {
                vd_error("Route load failed: %d", rv);
            }
        } else {
            vd_warn("Route file %s missing or not readable!", vcom_config.initial_routes_file);
        }
    }

    /* Console */

    console_err_t cons_rv = console_init(NULL); // defaults
    assert(cons_rv == CONSOLE_OK);

    /* Individual command sets */
    register_cmds();

    #if defined(VCOM_STATIC_CMDS)
    register_client_cmds();
    #endif

    void register_cmd_tcp(void);
    register_cmd_tcp();

    #if defined(VCOM_ALLOW_PLUGINS)
    // init plugins
    register_plugin_cmds();
    load_plugins();
    #endif

    /* a console or nii loop ensures we do not shutdown early */

    if (vcom_config.use_batch_input && vcom_config.use_nii) {
        vd_warn("Batch and NII enabled together! This is not supported.");
    }

    // if a file is given, use it instead of NII or Console
    if (vcom_config.use_batch_input) {
        vd_info("Starting BATCH mode, fail_exit=%d", vcom_config.batch_fail_exit);
        int colors_orig = vcom_config.colors;
        if (vcom_config.colors == VCOM_COLORS_AUTO) {
            vcom_config.colors = isatty(fileno(stdout));
        }

        /* resolve colors */
        FILE *infile = NULL;
        if (0 == strcmp(vcom_config.batch_file_name, "--")) {
            infile = stdin;
            vd_debug("Reading commands from stdin");
        } else {
            vd_debug("Reading commands from \"%s\"", vcom_config.batch_file_name);
            infile = fopen(vcom_config.batch_file_name, "r");
            if (!infile) {
                perror("open input file");
                return 1;
            }
        }
        batch_run(infile, vcom_config.batch_fail_exit);
        if (! vcom_config.batch_startup) {
            return 0;
        }
        vcom_config.colors = colors_orig;
        vcom_config.use_batch_input = false; // pretend we have a normal interactive session
    }

    if (vcom_config.use_nii) {
        vd_info("Starting NII mode on port %d", vcom_config.nii_port);

        if (vcom_config.colors == VCOM_COLORS_AUTO) {
            vcom_config.colors = 0;
        }

        // this is typically noreturn
        non_interactive_interpret_start(vcom_config.nii_port, vcom_config.logopt.dir);
        return 0;
    }
    else {
        if (vcom_config.colors == VCOM_COLORS_AUTO) {
            vcom_config.colors = true;
        }

        vd_info("Starting interactive console");

        static pthread_t hConsole;

        console_ctx_t *ctx = console_ctx_init(NULL, stdin, stdout);
        ctx->use_colors = (bool)vcom_config.colors;
        ctx->history_file = "history.txt"; // TODO make history file configurable

        if (ctx->use_colors) {
            snprintf(ctx->prompt, CONSOLE_PROMPT_MAX_LEN, "\x1b[36mvcom:%d> \x1b[m", vcom_config.cspopt.address);
        } else {
            snprintf(ctx->prompt, CONSOLE_PROMPT_MAX_LEN, "vcom:%d> ", vcom_config.cspopt.address);
        }

        pthread_create(&hConsole, NULL, console_task_posix, ctx);
        /* Wait here for console to end */
        pthread_join(hConsole, NULL);
        console_ctx_destroy(ctx);
    }

    /* shutting down */

    vd_debug("Stopping CSP server");
    csp_server_done();
    pthread_join(hCspServer, NULL);
    return 0;
}
